from srht.config import cfg
from srht.oauth import AbstractOAuthService, DelegatedScope
from hgsrht.types import User, OAuthToken

client_id = cfg("hg.sr.ht", "oauth-client-id")
client_secret = cfg("hg.sr.ht", "oauth-client-secret")
builds_client_id = cfg("builds.sr.ht", "oauth-client-id", default=None)

class HgOAuthService(AbstractOAuthService):
    def __init__(self):
        super().__init__("hg.sr.ht", OAuthToken, User)

        required_scopes = ["profile", "keys"] + ([
                "{}/jobs:write".format(builds_client_id)
            ] if builds_client_id else [])

        super().__init__(client_id, client_secret,
                required_scopes=required_scopes, delegated_scopes=[
                    DelegatedScope("info", "repository details", True),
                    DelegatedScope("data", "version controlled data", False),
                    DelegatedScope("access", "access control lists", True),
                ], user_class=User, token_class=OAuthToken)

oauth_service = HgOAuthService()
